{----------------------------------------------------------------}
{ Puissance 4 - Sub - 05/11/04                                  }
{----------------------------------------------------------------}
{$X+,J+}
Unit Tests;
Interface

Function TestGagne: Integer;
                    { 0 = pas de gagnant     }
                    { 1 = les jaunes gagnent }
                    { 2 = les rouges gagnent }


Const suite = 4;    { Nombre de jetons  aligner pour gagner     }
      vert = '6';   { Index du jeton de couleur verte            }
Var rouge: Boolean; { Le joueur courant possde les rouges ?     }
    first: Boolean; { Les rouges ont commenc ?                  }
    s: ShortString; { Index du jeton recherch dans la grille    }


{----------------------------------------------------------------}
{                                                                }
{                       }IMPLEMENTATION{                         }
{                                                                }
{----------------------------------------------------------------}
Uses SysUtils, Unit1;


{----------------------------------------------------------------}
{ TEST HORIZONTAL                                                }
{----------------------------------------------------------------}
Function TestHoriz(x, y: Integer): Boolean;
Var nb, i, j: Integer;
Begin
  Result := False;
  If (x > Form1.Grille.ColCount - suite) Or
    (Form1.Grille.Cells[x, y] <> s) Then Exit;

  nb := 0;
  For i := 0 To suite - 1 Do
  Begin
    If (Form1.Grille.Cells[x + i, y] = s) Then
      nb := nb + 1 Else nb := 0;
    If (nb >= suite) Then
    Begin
      nb := 0;
      For j := 0 To suite - 1 Do
        If (Form1.Grille.Cells[x + j, y] = s) And (nb < suite) Then
        Begin
          Form1.Grille.Cells[x + j, y] := vert;
          nb := nb + 1;
        End;
      Result := True;
      Break;
    End;
  End;
End;


{----------------------------------------------------------------}
{ TEST VERTICAL                                                  }
{----------------------------------------------------------------}
Function TestVerti(x, y: Integer): Boolean;
Var nb, i, j: Integer;
Begin
  Result := False;
  If (y > Form1.Grille.RowCount - suite) Or
    (Form1.Grille.Cells[x, y] <> s) Then Exit;

  nb := 0;
  For i := 0 To suite - 1 Do
  Begin
    If (Form1.Grille.Cells[x, y + i] = s) Then
      nb := nb + 1 Else nb := 0;
    If (nb >= suite) Then
    Begin
      nb := 0;
      For j := 0 To suite - 1 Do
        If (Form1.Grille.Cells[x, y + j] = s) And (nb < suite) Then
        Begin
          Form1.Grille.Cells[x, y + j] := vert;
          nb := nb + 1;
        End;
      Result := True;
      Break;
    End;
  End;
End;


{----------------------------------------------------------------}
{ TEST DIAGONAL 1 (\)                                            }
{----------------------------------------------------------------}
Function TestDiag1(x, y: Integer): Boolean;
Var nb, i, j: Integer;
Begin
  Result := False;
  If (y > Form1.Grille.RowCount - suite) Or
    (x > Form1.Grille.ColCount - suite) Or
    (Form1.Grille.Cells[x, y] <> s) Then Exit;

  nb := 0;
  For i := 0 To suite - 1 Do
  Begin
    If (Form1.Grille.Cells[x + i, y + i] = s) Then
      nb := nb + 1 Else nb := 0;
    If (nb >= suite) Then
    Begin
      nb := 0;
      For j := 0 To suite - 1 Do
        If (Form1.Grille.Cells[x + j, y + j] = s) Then
          Form1.Grille.Cells[x + j, y + j] := vert;
      Result := True;
      Break;
    End;
  End;
End;


{----------------------------------------------------------------}
{ TEST DIAGONAL 2 (/)                                            }
{----------------------------------------------------------------}
Function TestDiag2(x, y: Integer): Boolean;
Var nb, i, j: Integer;
Begin
  Result := False;
  If (y > Form1.Grille.RowCount - suite) Or
     (x < suite - 1) Or
     (Form1.Grille.Cells[x, y] <> s) Then Exit;

  nb := 0;
  For i := 0 To suite - 1 Do
  Begin
    If (Form1.Grille.Cells[x - i, y + i] = s) Then
      nb := nb + 1 Else nb := 0;
    If (nb >= suite) Then
    Begin
      nb := 0;
      For j := 0 To suite - 1 Do
        If (Form1.Grille.Cells[x - j, y + j] = s) Then
          Form1.Grille.Cells[x - j, y + j] := vert;
      Result := True;
      Break;
    End;
  End;
End;


{----------------------------------------------------------------}
{ TEST TOUTES LES DIRECTIONS                                     }
{----------------------------------------------------------------}
Function TestGagne: Integer;
Var x, y: Integer;
Begin
  {$B-}
  s := IntToStr(Integer(Not rouge) + 4);
  Result := 0;
  For y := 1 To Form1.Grille.RowCount - 1 Do
    For x := 0 To Form1.Grille.ColCount - 1 Do
      If (TestHoriz(x, y)) Or
         (TestVerti(x, y)) Or
         (TestDiag1(x, y)) Or
         (TestDiag2(x, y)) Then
      Begin
        If (rouge) Then Result := 1 Else Result := 2;
        Break;
      End;
End;


{----------------------------------------------------------------}
End.

