{----------------------------------------------------------------}
{ P4 - Defi Delphi n 3 - Sub0 - Developpez.com - 16/12/06       }
{----------------------------------------------------------------}
{ Salut! J'utilise une StringGrid et l'tat de chaque cellule    }
{ dans une chane directement accessible avec la proprit Cells }
{ correspond  l'index de l'image utilise dans ImageList1.      }
{ Les procdures de test sont issues de la dmo que j'avais dj }
{ ralise pour la page code source Delphi il ya longtemps...    }
{ J'ai ajout l'enregistrement et la restauration automatique du }
{ jeu courant dans un fichier nomm "p4.dat"... +               }
{----------------------------------------------------------------}
{$X+,J+}
Unit Unit1;
Interface
Uses Windows, Messages, SysUtils, Classes, Graphics, Controls,
     Forms, Dialogs, Grids, ImgList, StdCtrls, ExtCtrls;

Type
  TForm1 = Class(TForm)
    Conteneur: TPanel;
    Support: TPanel;
    Scores: TPanel;
    LabelJ: TLabel;
    LabelR: TLabel;
    Grille: TStringGrid;
    ImageList1: TImageList;

    Procedure FormCreate(Sender: TObject);
    Procedure FormDestroy(Sender: TObject);
    Procedure GrilleDrawCell(Sender: TObject;
      ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
    Procedure GrilleMouseMove(Sender: TObject;
      Shift: TShiftState; X, Y: Integer);
    Procedure GrilleMouseUp(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
  End;

Var Form1: TForm1;


{----------------------------------------------------------------}
{                                                                }
{                       }IMPLEMENTATION{                         }
{                                                                }
{----------------------------------------------------------------}
{$R *.dfm} Uses Tests;

Var bmp: TBitmap;    { Bitmap temporaire utilis pour ImageList1 }
    ccol: Integer;   { Colonne slectionne par la souris        }
    mjet: Integer;   { Nombre maximal de jetons pour la grille   }
    cjet: Integer;   { Nbr total de jetons jous dans la grille  }


{----------------------------------------------------------------}
{ FormCreate                                                     }
{----------------------------------------------------------------}
Procedure TForm1.FormCreate(Sender: TObject);
Var s: TStringList;
    i, j: Integer;
Begin
  If (Grille.ColCount <= 0) Or
     (Grille.RowCount <= 1) Then Halt(1);
  bmp := TBitmap.Create;
  ccol := -1;
  mjet := Grille.ColCount * (Grille.RowCount - 1);
  cjet := 0;

  { Chargement de la partie }
  If (FileExists('p4.dat')) Then Begin
    s := TStringList.Create;
    Try
      s.LoadFromFile('p4.dat');
      If (s.Count = Grille.RowCount + 3) Then Begin
        rouge := Boolean(StrToIntDef(s[0][1], 0));
        first := Boolean(StrToIntDef(s[0][2], 0));
        LabelR.Caption := IntToStr(StrToIntDef(s[1], 0));
        LabelJ.Caption := IntToStr(StrToIntDef(s[2], 0));
        For i := 0 To Grille.RowCount - 1 Do
          For j := 0 To Grille.ColCount - 1 Do
            Try
              If (Length(s[i + 3]) = Grille.ColCount) Then
                Grille.Cells[j, i] := s[i + 3][j + 1] Else
                Grille.Cells[j, i] := '1';
              If (i = 0) Then Grille.Cells[j, i] := '0';
              If (StrToIntDef(Grille.Cells[j, i], 0) >= 4) Then cjet := cjet + 1;
            Except
              Grille.Cells[j, i] := '0';
            End;
        End;
      Except
      End;
    s.Free;
  End;
End;


{----------------------------------------------------------------}
{ FormDestroy                                                    }
{----------------------------------------------------------------}
Procedure TForm1.FormDestroy(Sender: TObject);
Var s: TStringList;
    i, j: Integer;
    st: ShortString;
Begin
  bmp.Free;

  { Sauvegarde de la partie }
  s := TStringList.Create;
  s.Add(IntToStr(Integer(rouge)) + IntToStr(Integer(first)));
  s.Add(LabelR.Caption);
  s.Add(LabelJ.Caption);
  For i := 0 To Grille.RowCount - 1 Do Begin
    st := '';
    For j := 0 To Grille.ColCount - 1 Do
      st := st + Grille.Cells[j, i];
    s.Add(st);
  End;
  Try
    s.SaveToFile('p4.dat');
  Except End;
  s.Free;
End;


{----------------------------------------------------------------}
{ Dessin des jetons dans la grille                               }
{----------------------------------------------------------------}
Procedure TForm1.GrilleDrawCell(Sender: TObject;
  ACol, ARow: Integer; Rect: TRect; State: TGridDrawState);
Var index: Integer;
Begin
  index := StrToIntDef(Grille.Cells[ACol, ARow], 0);
  If (ARow = 0) And (index > 3) Then index := 3;
  If (ARow > 0) And (index < 1) Then index := 1;
  If (index > ImageList1.Count - 1) Then index := ImageList1.Count - 1;
  If (Grille.Cells[ACol, ARow] <> IntToStr(index)) Then
    Grille.Cells[ACol, ARow] := IntToStr(index);
  ImageList1.GetBitmap(index, bmp);
  If (ARow = 0) Then Rect.Top := Rect.Top - 3;
  Grille.Canvas.Draw(Rect.Left, Rect.Top, bmp);
End;


{----------------------------------------------------------------}
{ Slection de la colonne                                        }
{----------------------------------------------------------------}
Procedure TForm1.GrilleMouseMove(Sender: TObject;
  Shift: TShiftState; X, Y: Integer);
Var i, j: Integer;
Begin
  X := Grille.ScreenToClient(Mouse.CursorPos).X;
  If (X < 0) Then X := 0;
  If (X >= Grille.Width - Grille.DefaultColWidth) Then
    X := Grille.Width - Grille.DefaultColWidth;
  For i := 0 To Grille.ColCount - 1 Do
    If (i <> ccol) And
       (X >= Grille.CellRect(i, 0).Left) And
       (X < Grille.CellRect(i, 0).Left + Grille.DefaultColWidth) And
       (Grille.Cells[i, 1] = '1') Then Begin
      ccol := i;
      Grille.Cells[i, 0] := IntToStr(Integer(rouge) + 2);
      For j := 0 To Grille.ColCount - 1 Do
        If (j <> ccol) Then Grille.Cells[j, 0] := '0';
    End;
End;


{----------------------------------------------------------------}
{ Ajot d'un jeton dans la grille                                }
{----------------------------------------------------------------}
Procedure TForm1.GrilleMouseUp(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
Var i, j: Integer;
Begin
  { Chute du jeton }
  If (Grille.Cells[ccol, 1] = '1') Then Begin
    cjet := cjet + 1;
    For i := 1 To Grille.RowCount - 1 Do
      If (Grille.Cells[ccol, i] = '1') Then Begin
        Grille.Cells[ccol, i] := IntToStr(Integer(rouge) + 4);
        Grille.Cells[ccol, 0] := '0';
        If (i > 1) Then Grille.Cells[ccol, i - 1] := '1';
        Grille.Refresh;
        Sleep(600 Div Grille.RowCount);
      End;
    rouge := Not rouge;
  End;

  { Victoire ? }
  i := TestGagne;
  If (cjet >= mjet) And (rouge = first) And (i = 0) Then i := 3;
  If (i > 0) Then Begin
    Grille.Refresh;
    Beep;
    If (i = 1) Then Begin
      LabelJ.Caption := IntToStr(StrToIntDef(LabelJ.Caption, -1) + 1);
      ShowMessage('Les jaunes gagnent!');
    End;
    If (i = 2) Then Begin
      LabelR.Caption := IntToStr(StrToIntDef(LabelR.Caption, -1) + 1);
      ShowMessage('Les rouges gagnent!');
    End;
    If (i = 3) Then ShowMessage('Plus de jetons!');
    For i := 1 To Grille.RowCount - 1 Do
      For j := 0 To Grille.ColCount - 1 Do
        Grille.Cells[j, i] := '1';
    first := rouge;
    cjet := 0;
  End;

  { Jeton suivant... }
  If (Grille.Cells[ccol, 1] = '1') Then
    Grille.Cells[ccol, 0] := IntToStr(Integer(rouge) + 2);
  Grille.Refresh;
End;


{----------------------------------------------------------------}
End.

